<?php
/* --------------------------------------------------------------
   RedirectServiceFactory.php 2020-07-22
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
declare(strict_types=1);

namespace Gambio\Admin\Modules\RedirectRules\Factories;

use Gambio\Admin\Modules\RedirectRules\RedirectService;
use Gambio\Admin\Modules\RedirectRules\RedirectServiceInterface;
use Gambio\Admin\Modules\RedirectRules\Repository\RedirectRepositoryInterface;

class RedirectServiceFactory
{
    protected $repository;
    
    
    public function __construct(RedirectRepositoryInterface $repository)
    {
        $this->repository = $repository;
    }
    
    
    public function service(): RedirectServiceInterface
    {
        return new RedirectService($this->repository);
    }
}
